'use strict';

var _nock = require('nock');

var _api = require('../api');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_nock.back.fixtures = __dirname + '/__fixtures__/';
_nock.back.setMode('lockdown');

describe('api', function () {
  describe('.getUser', function () {
    it('gets a user by username', function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(done) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _nock.back)('blackxored.json', function () {
                  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(nockDone) {
                    var user;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return (0, _api.getUser)('blackxored');

                          case 2:
                            user = _context.sent;

                            expect(user).toMatchSnapshot();

                            nockDone();
                            done();

                          case 6:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, undefined);
                  }));

                  return function (_x2) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, undefined);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  });

  describe('.getRankForLanguage', function () {
    it('returns a specific rank for a language', function (done) {
      (0, _nock.back)('blackxored.json', function () {
        var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(nockDone) {
          var result;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.t0 = _api.getRankForLanguage;
                  _context3.next = 3;
                  return (0, _api.getUser)('blackxored');

                case 3:
                  _context3.t1 = _context3.sent;
                  result = (0, _context3.t0)('javascript', _context3.t1);

                  expect(result).toMatchSnapshot();

                  nockDone();
                  done();

                case 8:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, undefined);
        }));

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }());
    });
  });

  describe('.getUserBestRankWorldwide', function () {
    it('returns the rank where the user is best-ranked worlwide', function (done) {
      (0, _nock.back)('blackxored.json', function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(nockDone) {
          var result;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.t0 = _api.getUserBestRankWorldwide;
                  _context4.next = 3;
                  return (0, _api.getUser)('blackxored');

                case 3:
                  _context4.t1 = _context4.sent;
                  result = (0, _context4.t0)(_context4.t1);


                  expect(result.language).toEqual('ruby');

                  nockDone();
                  done();

                case 8:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, undefined);
        }));

        return function (_x4) {
          return _ref4.apply(this, arguments);
        };
      }());
    });
  });

  describe('.getTopUsers', function () {
    it('returns the list of top users', function (done) {
      (0, _nock.back)('top-users.json', function () {
        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(nockDone) {
          var result;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.next = 2;
                  return (0, _api.getTopUsers)();

                case 2:
                  result = _context5.sent;

                  expect(result).toMatchSnapshot();

                  expect(result[0].login).toEqual('freecodecamp');

                  nockDone();
                  done();

                case 7:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, undefined);
        }));

        return function (_x5) {
          return _ref5.apply(this, arguments);
        };
      }());
    });
  });
});